/*********************************************************************
Copyright 1992 by Digital Press/Digital Equipment Corporation, Elias
Israel, and Erik Fortune

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation.  Digital Equipment Corporation and the
authors make no representations about the suitability of this software
for any purpose.  It is provided "as is" without express or implied
warranty.

DIGITAL EQUIPMENT CORPORATION AND THE AUTHORS DISCLAIM ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL DIGITAL EQUIPMENT
CORPORATION OR THE AUTHORS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

This material is reproduced with permission from _The X Window System
Server: X Version 11, Release 5_, by Elias Israel and Erik Fortune.
(Copyright 1992, Digital Press, Digital Equipment Corporation, One
Burlington Woods Drive, Burlington, MA 01803)
*********************************************************************/

#include "strings.h"

#include <X11/Xproto.h>
#include "misc.h"
#include "scrnintstr.h"
#include "ddxScreens.h"

#ifndef NO_TIMEOUT
#include <signal.h>

int	timeToLive=	15;

void
osInitTimeout()
{
extern	int	GiveUp();
    signal(SIGALRM,GiveUp);
    alarm(timeToLive);
    return;
}
#endif

static int
ddxProcessScreenArgument( char *arg )
{
int  hw;
char *hwName,*tmp;

    for (hw=0;hw<nKnownScreens;hw++) {
	hwName = pKnownScreens[hw]->name;
	if (strncmp(arg,hwName,strlen(hwName))==0) {
	    ddxScreenDesc *pDesc = pKnownScreens[hw];
	    ddxScreenReq *pReq = &requestedScreens[nRequestedScreens++];
	    (*pDesc->requestFunc)(pDesc,pReq);

	    if (pReq->setValueFunc && (tmp=strchr(arg,','))!=NULL) {
		char *str = strdup(tmp+1);
		char *name,*value;
		tmp = str;
		while (*tmp) {
		    name = tmp;
		    while ((*tmp) && (*tmp!='=') && (*tmp!=',')) 
			tmp++;
		    if (*tmp=='=') {
			*tmp++ = '\0';
			value = tmp;
			while ((*tmp) && (*tmp!=','))
			    tmp++;
			if (*tmp)
			    *tmp++ = '\0';
		    }
		    else {
			value = NULL;
			if (*tmp)
			    *tmp++ = '\0';
		    }
		    (*pReq->setValueFunc)(pReq,name,value);
		}
		free(str);
	    }
	    return 1;
	}
    }
    return 0;
}

int
ddxProcessArgument(argc,argv,i)
int	argc;
char	*argv[];
int	i;
{
#ifndef NO_TIMEOUT
    if (strcmp(argv[i],"-live")==0) {
	if (++i<argc) {
	    timeToLive=	atoi(argv[i]);
	    return 2;
	}
    }
#endif
    if (strcmp(argv[i],"-all")==0) {
	ddxMaxScreens = MAXSCREENS;
	return 1;
    }
    if (strcmp(argv[i],"-hw")==0) {
	if ((++i<argc)&&(nRequestedScreens<MAXSCREENS)) {
	    if (ddxProcessScreenArgument( argv[i] ))
		return 2;
	}
    }
    return 0;
}

void
ddxUseMsg()
{
int i;
#ifndef NO_TIMEOUT
    ErrorF("-live <n>	       run <n> seconds before exiting\n");
#endif
    ErrorF("-hw <type>,<args>      Specifies a screen to use.\n");
    ErrorF("The following screen types are legal:\n");
    for (i=0;i<nKnownScreens;i++) {
	ErrorF("   %s",pKnownScreens[i]->name);
	if (pKnownScreens[i]->screenUseMsg) {
	    int tmp = 22 - 3 - strlen(pKnownScreens[i]->name);
	    while ( tmp>= 0 ) {
		ErrorF(" ");
		tmp--;
	    }
	    (*pKnownScreens[i]->screenUseMsg)(pKnownScreens[i]);
	    ErrorF("\n");
	}
    }
    return;
}

