#define	NEED_EVENTS
#include <X11/X.h>
#include <X11/Xproto.h>
#include "misc.h"
#include "inputstr.h"

#include "genInput.h"

/***====================================================================***/
/***                     ASSORTED MOUSE FUNCTIONS                       ***/
/***====================================================================***/

/* ARGSUSED */
static int
genGetMotionEvents( buf, start, stop )
xTimecoord	*buf;
CARD32		start, stop;
{
    /* no motion buffer */
    return 0;
}

/***====================================================================***/

/* ARGSUSED */
static void
genChangePointerControl( pDev, pCtrl )
DeviceIntPtr	pDev;
PtrCtrl		*pCtrl;
{
    /* can't control a pointer that doesn't exist */
    return;
}

/***====================================================================***/

	/*\
	 * Mouse open/close/init procedure
	\*/

/* ARGSUSED */
static int
genMouseProc(pMouse, what, argc, argv)
DevicePtr	pMouse;
int		what;
int		argc;
char		*argv[];
{
    switch (what) {
	case DEVICE_INIT: 
	    InitPointerDeviceStruct(
		pMouse, NULL, 0, genGetMotionEvents, genChangePointerControl, 0);
	    break;
	case DEVICE_ON: 
	case DEVICE_OFF: 
	case DEVICE_CLOSE:
	    break;
    }
    return Success;
}

/***====================================================================***/

	/*\
	 * OS specific input routines
	 * InitInput() --
	 *	Does whatever OS-specific magic is necessary to
	 *	initialize all input devices.
	 * ProcessInputEvents() --
	 *      OS-specific code which reads input events from devices
	 *	and reports them to the DIX layer.   The DIX layer
	 *	will distribute them as appropriate.
	\*/
void
InitInput()
{
DevicePtr	ptr, kbd;
    
    ptr=	AddInputDevice(genMouseProc, TRUE);
    kbd=	AddInputDevice(genKeyboardProc, TRUE);

    RegisterPointerDevice(ptr);
    RegisterKeyboardDevice(kbd);
    return;
}

/***====================================================================***/

void
ProcessInputEvents()
{
    /* no input devices means no input events.  this is easy */
    return;
}

/***====================================================================***/

static	unsigned	lastEventTime=	0;

int
TimeSinceLastInputEvent()
{
   if (lastEventTime == 0) 
	lastEventTime=	GetTimeInMillis();
   return GetTimeInMillis() - lastEventTime;
}
