#include <X11/Xproto.h>
#include "misc.h"

	/*\
	 * OS and device specific error routines
	 * ddxGiveUp()
	 * AbortDDX() --
	 *	Called to shut down when the server encounters an 
	 *	unrecoverable error.   They should free any ddx
	 *	resources (close files, etc) as necessary and exit.
	 *	It's not clear how they differ.
	\*/
void
ddxGiveUp()
{
    /* add any cleanup code here */
    exit(1);
}

void
AbortDDX()
{
    /* add any cleanup code here */
    exit(1);
}

	/*\
	 * OS and device specific Argument handling routines.
	 * ddxProcessArgument(argc,argv,i)
	 *	Hook for an implementation to add flags
	 *	specific to an operating system or device.
	 * ddxUseMsg()
	 *	Called whenever the OS-layer prints a "usage"
	 *	message.   Describe implementation specific
	 *	flags here.
	\*/
int
ddxProcessArgument(argc,argv,i)
int	argc;
char	*argv[];
int	i;
{
    /* generic implementation doesn't recognize any arguments */
    return(0);
}

void
ddxUseMsg()
{
   /* generic implementation doesn't accept any arguments */
    return;
}

