/*********************************************************************
Copyright 1992 by Digital Press/Digital Equipment Corporation, Elias
Israel, and Erik Fortune

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation.  Digital Equipment Corporation and the
authors make no representations about the suitability of this software
for any purpose.  It is provided "as is" without express or implied
warranty.

DIGITAL EQUIPMENT CORPORATION AND THE AUTHORS DISCLAIM ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL DIGITAL EQUIPMENT
CORPORATION OR THE AUTHORS BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

This material is reproduced with permission from _The X Window System
Server: X Version 11, Release 5_, by Elias Israel and Erik Fortune.
(Copyright 1992, Digital Press, Digital Equipment Corporation, One
Burlington Woods Drive, Burlington, MA 01803)
*********************************************************************/

#include <X11/X.h>
#include "misc.h"

#include "commonOS.h"
#include "xosInput.h"

#include "scrnintstr.h"
#include "ddxScreens.h"

static int	xosHaveVS = 0;

void
xosVSLost()
{
int		 i,ok;
ScreenPtr	 pScreen;
ddxScreenPriv	*priv;

    xosHaveVS = 0;
    ok = 1;
    for (i=0;i<screenInfo.numScreens;i++) {
	pScreen = screenInfo.screens[i];
	priv = (ddxScreenPriv *)pScreen->devPrivates[ddxScreenPrivIndex].ptr;
	if ( priv && priv->vsStateChanged )
	    ok = (*priv->vsStateChanged)( pScreen, 0 ) && ok;
    }
    /* TBD (FOURTH STAGE)
     *    This function is called (normally from a signal handler) to
     * tell the server that it is about to lose access to a shared
     * virtual screen.
     *    If the vsStateChanged function of some screen returns FALSE,
     * that screen does not want to yield the virtual terminal.
     * If your operating system requires you to acknowledge or refuse
     * a switch away from your virtual terminal, do so here.
     */
    return;
}

void
xosVSGained()
{
int		 i;
ScreenPtr	 pScreen;
ddxScreenPriv	*priv;

    /*
     * TBD (FOURTH STAGE)
     *     This function is called (usually from a signal handler) to
     * let the server know that it has control of a shared virtual 
     * screen again.   If your system requires applications to
     * acknowledge a switch to a virtual screen, do so here.
     */
    xosHaveVS = 1;
    for (i=0;i<screenInfo.numScreens;i++) {
	pScreen = screenInfo.screens[i];
	priv = (ddxScreenPriv *)pScreen->devPrivates[ddxScreenPrivIndex].ptr;
	if ( priv && priv->vsStateChanged )
	    (*priv->vsStateChanged)( pScreen, 1 );
    }
    return;
}

